#! /usr/bin/perl -w
# --------------------------------------------------------------------------------
# Script to extract weekly produced energy from: http://192.168.xxx.xxx/appliances/interval_logs
#
# Usage:  parseappliances.pl xmlfile
# --------------------------------------------------------------------------------
#	this is really ugly,
#	Synology people: please fix perl XML libraries in DSM 4.1!!!
BEGIN {
  require XML::Parser::Expat;
    my $saved_version=$XML::Parser::Expat::VERSION;
      $XML::Parser::Expat::VERSION= '2.36';
        require XML::Parser;
          $XML::Parser::Expat::VERSION= $saved_version;
          }
#           use XML::Parser;
           use LWP::Simple;

# --------------------------------------------------------------------------------------------
#  read command line parameters
my $xmlfile       = $ARGV[0];                    		# the file to parse
my $outfile_hours = $ARGV[1];                    		# the file to build 
my $outfile_days  = $ARGV[2];                    		# the file to build 
my $device_name   = $ARGV[3];                    		# name of device to read
my $PV_API_key    = $ARGV[4];                    		# API-key for PVoutput
my $PV_sid		  = $ARGV[5];                    		# sid for PVoutput
# --------------------------------------------------------------------------------------------
#start of script
open (OUTFILE1, ">>$outfile_hours") || die "open outputfile1:$!";
open (OUTFILE2, ">>$outfile_days") ||  die "open outputfile2:$!";
 
# initialize parser object and parse the string
my $parser = XML::Parser->new();
$parser->setHandlers( Start => \&handle_start,
		      Char  => \&handle_char,
		      End   => \&handle_end,     );
                                                                             
my ( $periodend, $producedfound,$log_date,$current_key  );
my @data ;

$periodend=1;
$producedfound=0;

# Parse the file, calling the handlers in the mean time.
my $tree = $parser->parsefile( $xmlfile );

# retrieve most recent standings from PVoutput server

my ( $old_year, $old_month , $old_day, $dayoutput, @pvlog, @temp, $url, $content, $pvurl);
  $pvurl = "http://pvoutput.org/service/r2/";
  $url = $pvurl."getoutput.jsp?key=".$PV_API_key."&sid=".$PV_sid;
  $content = get $url;
  die "Couldn't get $url" unless defined $content;
  @pvlog = split /,/,$content;

# sort the parsed file
  my @new = sort  @data ;

# write a file-line for each parsed line
foreach (@new)
{
	# make an output line of the data
	my @ding = split /\s+/,$_ ;
	my $line = $ding[0]."-".$ding[1]."-".$ding[2]." ".$ding[3].":00 "."".$ding[4]."\r\n" ;
	my $current_date;
	if (not $old_year) {
		$old_day   =$ding[0];
		$old_month =$ding[1]; 
	    $old_year  =$ding[2];
		$dayoutput=0;
	   }
	if (($ding[2] == $old_year) && ($ding[1] == $old_month) && ($ding[0] == $old_day)) {
        #add total of hour to daytotal
	    $dayoutput = $dayoutput + $ding[4];
	   }
	else
 	   { 
       # write dayline and reset dayvalues
	   $dayline = $old_year."-".$old_month."-".$old_day.";".$dayoutput."\r\n" ;
	   $current_date = $old_year.$old_month.$old_day;
	   print (OUTFILE2 $dayline);
	   if ($pvlog[0] <= $current_date) {
	       # update pvoutput with new dayvalues
	       $dayoutput = int($dayoutput + $dayoutput/abs($dayoutput*2));	   
           $url = $pvurl."addoutput.jsp?key=";
		   my $curl = `curl -d "data=$current_date,$dayoutput" -H "X-Pvoutput-Apikey: $PV_API_key" -H "X-Pvoutput-SystemId: $PV_sid" $url`
		   #$url = $pvurl."addoutput.jsp?key=".$PV_API_key."&sid=".$PV_sid."&d=".$current_date;#."&g=".$dayoutput;
           #$content = get $url;
           #die "Couldn't get $url" unless defined $content;
           #@temp = split /,/,$content;
		   #if (($content ne 'OK 200: Added Output') && ($content ne 'OK 200: Updated Output')) {	
           #    print STDOUT $content;
			#   }
		   }
  	   $old_day  = $ding[0];
	   $old_month= $ding[1];
	   $old_year = $ding[2];
	   $dayoutput=0;
	   }
	print (OUTFILE1 $line);
}
close (OUTFILE1);
close (OUTFILE2);
# end of script
# --------------------------------------------------------------------------------------------

sub makedate
{
my ( $year,$month,$day,$hour );
my $result;

	#print ("makedate from $log_date\n");
	$log_date =~ s/[-:T+]/ /g;
	my @items = split /\s+/, $log_date ;

	$year = $items[0];
	$month = sprintf("%02d",$items[1]);
	$date = sprintf("%02d",$items[2]);

	# stretch is one hour off!
	$hour = sprintf("%02d",$items[3]+1);
	
#	print(" $hour:0 $date-$month-$year;") ;

	#print("date is $date $month $year at $hour:00\n");
	#return ($hour . ":00 " . $date . "-" . $month . "-" . $year . ";" );
	#return in the sequence so it can be sorted.
	return ( $date." ".$month." ".$year." ".$hour." ");

}

sub handle_char
{
  my ($p, $text, %attrs ) = @_;

    if ( $periodend == 0 ) {
	if ( $current_key eq 'measurement' ) {
		
		my $date = makedate ;
		#printf("$text\n") ;
		push( @data, $date . $text ) ;
	}
	$current_key="";
    }

    if ( $producedfound == 0 ) {
	#
	if ( $text eq 'electricity_produced' ) {
		$producedfound=1;
		$periodend=0;
	}
    }

}



sub handle_end
{
  my ($p, $elmt ) = @_;
  if ( $elmt eq 'period' ) {
	#printf("Period end found\n");
	$periodend=1;
  }
}



sub handle_start()
{
  my ($p, $elmt, %attrs ) = @_;
  $current_key = $elmt ;
	# get the log_date attribute
	if ( $elmt eq 'measurement' ) {
		if( %attrs ) {
		        while( my( $key, $value ) = each( %attrs )) {
				if ( $key eq 'log_date' ) {
					$log_date = $value ;
				}
		        }
		}
	}
}




